#include <iostream>
#include <vector>
using namespace std;

vector<int> primes;

void era()
{
	vector<bool> is_p(10001, true);
	for(int p=2; p<=10000; ++p)
		if( is_p[p] )
			for(int q=p+p; q<=10000; q+=p)
				is_p[q] = false;
	for(int p=2; p<=10000; ++p)
		if( is_p[p] )
			primes.push_back(p);
}

long long sumdiv( int N )
{
	long long ans = 1;
	for(int i=0; i!=primes.size() && N!=1; ++i)
	{
		long long p = primes[i];
		long long k = 0;
		long long mul = 1;
		long long pk = 1;
		while( N%p == 0 )
			++k, N/=p, pk*=p, mul+=pk;
		ans *= mul;
	}
	if( N != 1 )
		ans *= (1+N);
	return ans;
}

const char* solve(int N)
{
	long long sd = sumdiv(N) - N;
	if( sd == N )
		return "perfect number";
	if( sd < N )
		return "deficient number";
	return "abundant number";
}

int main()
{
	era();

	int N;
	while(cin>>N && N>0 && cin)
		cout << solve(N) << endl;
	return 0;
}
