#include <iostream>
#include <vector>
#include <string>
using namespace std;

void exec(char c, vector<string>& m, int& Y, int& X, int& D, int H, int W)
{
	switch(c)
	{
	case 'U':
		D = 0;
		if( Y>0 && m[Y-1][X]=='.' ) Y--;
		break;
	case 'D':
		D = 2;
		if( Y<H-1 && m[Y+1][X]=='.' ) Y++;
		break;
	case 'L':
		D = 3;
		if( X>0 && m[Y][X-1]=='.' ) X--;
		break;
	case 'R':
		D = 1;
		if( X<W-1 && m[Y][X+1]=='.' ) X++;
		break;
	case 'S':
		{
			int dx = (D==3 ? -1 : D==1 ? +1 : 0);
			int dy = (D==0 ? -1 : D==2 ? +1 : 0);
			for(int i=1;; ++i)
			{
				int y = Y+i*dy;
				int x = X+i*dx;
				if( x<0 || x>=W || y<0 || y>=H ) break;
				if( m[y][x] == '*' ) {
					m[y][x] = '.';
					break;
				}
				if( m[y][x] == '#' ) {
					break;
				}
			}
		}
		break;
	}
}

void solve( vector<string> m, string cmd, int H, int W )
{
	int Y, X, D;
	for(int y=0; y!=H; ++y)
	for(int x=0; x!=W; ++x)
		if( m[y][x]=='^' )
			Y=y,X=x,D=0;
		else if( m[y][x]=='v' )
			Y=y,X=x,D=2;
		else if( m[y][x]=='<' )
			Y=y,X=x,D=3;
		else if( m[y][x]=='>' )
			Y=y,X=x,D=1;
	m[Y][X] = '.';

	for(int i=0; i!=cmd.size(); ++i)
		exec(cmd[i], m, Y, X, D, H, W);

	if(D==0)
		m[Y][X] = '^';
	else if(D==1)
		m[Y][X] = '>';
	else if(D==2)
		m[Y][X] = 'v';
	else if(D==3)
		m[Y][X] = '<';

	for(int y=0; y!=H; ++y)
		cout << m[y] << endl;
}

int main()
{
	int T; cin>>T;
	while(T--)
	{
		static bool first = true;
		if(first) first=false; else cout<<endl;

		int H, W; cin >> H >> W;
		vector<string> m(H);
		for(int i=0; i!=H; ++i)
			cin >> m[i];

		int N; cin >> N;
		string cmd; cin >> cmd;
		solve(m, cmd, H, W);
	}
	return 0;
}
