#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
using namespace std;

int gcd(int a, int b)
{
	while(a)
	{
		int bb = b%a;
		b = a;
		a = bb;
	}
	return b;
}

int lcm(int a, int b)
{
	return a/gcd(a,b)*b;
}

vector<int> parse(const string& s)
{
	vector<int> ans;
	for(int i=0; i<s.size(); i+=2)
		ans.push_back( (s[i]-'0')*16 + s[i+1]-'0' );
	return ans;
}

void optimize(vector<int>& s)
{
	int ding = s.size();
	for(int i=1; i<s.size(); ++i)
		if( s[i] )
			ding = gcd(ding, i);

	vector<int> t;
	for(int i=0; i<s.size(); i+=ding)
		t.push_back(s[i]);
	s = t;
}

void print(const vector<int>& v)
{
	for(int i=0; i!=v.size(); ++i)
		cout << hex << uppercase << setw(2) << setfill('0') << v[i];
	cout << endl;
}

int main()
{
	int t; cin>>t;
	while(t--)
	{
		int N; cin>>N;
		vector< vector<int> > old;
		int len = 1;
		while(N--)
		{
			string s;
			cin >> s;
			if( len<=1024 )
			{
				vector<int> t = parse(s);
				optimize(t);
				old.push_back(t);
				len = lcm(t.size(), len);
			}
		}
		if( len <= 1024 )
		{
			vector<int> ans(len);
			for(int i=0; i!=old.size(); ++i)
			for(int j=0; j!=old[i].size(); ++j)
				ans[j*len/old[i].size()] |= old[i][j];
			print(ans);
		}
		else
		{
			cout << "Too complex." << endl;
		}
	}
	return 0;
}
