#include <iostream>
#include <vector>
using namespace std;

static const int INF = 0x7ffffffe;

void solve(int m[50][50], int M, int a, int b)
{
	vector< vector<int> > conn(M);
	for(int i=0; i!=M; ++i)
	for(int j=0; j!=M; ++j)
		if( m[i][j] || i==j )
			conn[i].push_back(j);

	vector<int> scoreA(M*M), scoreB(M*M);
	for(int A=0; A!=M; ++A)
	for(int B=0; B!=M; ++B)
		scoreA[A*M+B] = (A==B ? 0 : INF),
		scoreB[A*M+B] = (A==B ? 0 : INF);

	for(int t=0; t<M*M; ++t)
	{
		bool changed = false;

		// A's move
			for(int A=0; A!=M; ++A)
			for(int B=0; B!=M; ++B) if(A!=B)
			{
				int before = scoreA[A*M+B];
				scoreA[A*M+B] = -1;
				for(int i=0,e=conn[A].size(); i!=e; ++i)
					scoreA[A*M+B] = max(scoreA[A*M+B], scoreB[conn[A][i]*M+B]);
				if( before != scoreA[A*M+B] )
					changed = true;
			}

		// B's
			for(int A=0; A!=M; ++A)
			for(int B=0; B!=M; ++B) if(A!=B)
			{
				int before = scoreB[A*M+B];
				scoreB[A*M+B] = INF;
				for(int i=0,e=conn[B].size(); i!=e; ++i)
					scoreB[A*M+B] = min(scoreB[A*M+B], 1+scoreA[A*M+conn[B][i]]);
				if( before != scoreB[A*M+B] )
					changed = true;
			}
		if( !changed )
			break;
	}
	if( scoreA[a*M+b]==INF )
		cout << "infinity" << endl;
	else
		cout << scoreA[a*M+b] << endl;
}

int main()
{
	int N; cin >> N;
	while(N--)
	{
		int M; cin >> M;
		int m[50][50];
		for(int y=0; y!=M; ++y)
		for(int x=0; x!=M; ++x)
			cin >> m[y][x];
		int a; cin >> a;
		int b; cin >> b;
		solve(m, M, a, b);
	}
	return 0;
}
